# %% bcmfR R-SOURCE %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
# _________________________________________________________________________
#
#    bcmf_base_15.R
# _________________________________________________________________________
#
# %% Functions to get and set the session information
# %% Miscellaneous base functions





# === [trim_leading_hash] =================================================
trim_leading_hash <- function(str) {
  
  hashblanked <- chartr("#", " ", str)
  str_trim(hashblanked)
  
}
# ___ (trim_leading_hash) ________________________________________________


# == SESSION INFO =========================================================


# == init session info
# SESSION.Info <- list(date     = date(),
#                      program  = PROG.Info$version,
#                      user     = "",
#                      project  = "",
#                      task     = "",
#                      venue    = "")

### ==
# getInfoDate <- function() {
#   
#   # -- this is a primitive print method, not yet S3
#   as.data.frame(get("INFO.DATE", envir = .GlobalEnv))
# } # -- getInfoDate.


# resetDate <- function() {
#   SESSIONInfo$date <<- date()
#   return(SESSIONInfo$date)
# }
# 
# setDate <- function(date) {
#   
#   SESSIONInfo$date <<- date
#   return(SESSIONInfo$date)
# }
# 
# getDate <- function() {
#   SESSIONInfo$date
# }


# setInfoDate <- function(datetime = date(),
#                         comments = "") {
#   
#   assign("INFO.DATE", list(datetime = datetime,
#                            comments = comments),
#          envir = .GlobalEnv)
#   
#   # do only for values
#   # assign("InfoDateTime", INFO.DATE$time, envir = .GlobalEnv)
#   
#   getInfoDate()
# } # setInfoDate.
# 
# # setInfoDate programming details now
# setInfoDate()



# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# = to get and set user info

# getUserInfo <- function() {
#   
#   # this is a primitive print method, not yet S3
#   as.data.frame(get("User.Info", envir = .GlobalEnv))
#   
# } # getInfoUser.
# 
# setUserInfo <- function(username    = "Unknown",
#                         affiliation = "",
#                         address     = "", 
#                         email       = "",
#                         phone       = "",
#                         comments    = "") {
#   
#   assign("User.Info", list(username    = username,
#                            affiliation = affiliation,
#                            address     = address, 
#                            email       = email,
#                            phone       = phone,
#                            comments    = comments),
#          envir = .GlobalEnv)
#   
#   # do only for values
#   # assign("InfoUserName", INFO.USER$username, envir = .GlobalEnv)
#   
#   getUserInfo()
# } # setUserInfo.
# 
# # initialize INFO.USER with username "Unknown"
# ######### setUserInfo()


# getVenueInfo <- function() {
#   
#   # this is a primitive print method, not yet S3
#   as.data.frame(get("Venue.Info", envir = .GlobalEnv))
#   
# } # getInfoVenue.
# 
# # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# # = to get and set venue information (meeting, workshop)
# 
# 
# setVenueInfo <- function(auspices    = "Unknown",
#                          when        = "",
#                          organizer   = "", 
#                          location    = "",
#                          address     = "",
#                          comments    = "") {
#   
#   assign("Venue.Info", list(auspices    = auspices,
#                             when        = when,
#                             organizer   = organizer, 
#                             location    = location,
#                             address     = address,
#                             comments    = comments),
#          envir = .GlobalEnv)
#   
#   # do only for values
#   # assign("InfoVenueAuspices", INFO.VENUE$auspices, envir = .GlobalEnv)
#   
#   getVenueInfo()
# } # setVenueInfo.
# 
# # initialize INFO.VENUE with "Unknown"
# #########setVenueInfo()

# ===INIT INFO END=========================================================.


# ===INIT TEST BEGIN=======================================================
#
# # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# # = to get and set current TEST.CHEMICAL
# 
# getTestChemical <- function() {
#   
#   # this is a primitive print method, not yet S3
#   as.data.frame(get("Test.Chemical", envir = .GlobalEnv))
# }
# 
# ### == init empty Test.Chemical
# Test.Chemical <- list(chemname   = "",
#                       casno      = "",
#                       smiles     = "",
#                       chemform   = "",
#                       chemid     = "",
#                       speciation = "",
#                       solvent    = "",
#                       comments   = "")
# 
# ### == function to set Test.Chemical
# setTestChemical <- function(chemname   = "",
#                               casno      = "",
#                               smiles     = "",
#                               chemform   = "",
#                               chemid     = "",
#                               speciation = "",
#                               solvent    = "",
#                               comments   = "") {
#   # --
#   Test.Chemical <<- list(chemname   = chemname,
#                          casno      = casno,
#                          smiles     = smiles,
#                          chemform   = chemform,
#                          chemid     = chemid,
#                          speciation = speciation,
#                          solvent    = solvent,
#                          comments   = comments)
#   
#   # -- return (later print)
#   Test.Chemical
# 
# } # set.Test.Chemical.

### ==
# addChemID <- function(chemid) {
#   # -- set chemid field directly
#   Test.Chemical$chemid <- chemid
#   # -- return (later print)
#   Test.Chemical
# }


# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# = to get and set Test.CWater, the (constant) exposure concentration

# getTestCWater <- function() {
#   
#   # this is a primitive print method, not yet S3
#   as.data.frame(get("Test.CWater", envir = .GlobalEnv))
# }


# == setTestCWater =======================================================
# -- function to set Test.CWater and Test.CWater.Value
# -- todo: annotation for roxygen
# setTestCWater <- function(value     = NA,                           
#                             userunit  = "[ugX/L]",
#                             dimension = "[massChem(1).volWater(-1)]",
#                             comments  = "") {
#   
#   # build the list called Test.CWater in .GlobalEnv
#   assign("Test.CWater", list(value     = value,
#                              userunit  = userunit,
#                              dimension = dimension,
#                              comments  = comments),
#          envir = .GlobalEnv)
#   
#   # define Test.CWater.Value as a 'scalar' variable
#   assign("Test.CWater.Value", Test.CWater$value, envir = .GlobalEnv)
#   
#   # if user, or GUI, changed the dimension, repair and balk
#   if (!Test.CWater$dimension == "[massChem(1).volWater(-1)]") {
#     setTestCWater(dimension = "[massChem(1).volWater(-1)]")
#     print("setTestCWater: dimension cannot be set.")
#   }
#   
#   # print Test.CWater
#   getTestCWater()
# }
# == setTestCWater =====.


# initialize with missing value
#########setTestCWater()


# ==[getTestTStart]========================================================
# to get and set Test.TStart, starting time uptake phase
# usually set at zero

# getTestTStart <- function() {
#   
#   # this is a primitive print method, not yet S3
#   as.data.frame(get("Test.TStart", envir = .GlobalEnv))
# }
# 
# # function to set Test.TStart and Test.TStart.Value
# # todo: annotation for roxygen
# setTestTStart <- function(value     = NA,                           
#                             userunit  = "[d]",
#                             dimension = "[time(1)]",
#                             comments  = "") {
#   
#   # build the list called Test.TStart in .GlobalEnv
#   assign("Test.TStart", list(value     = value,
#                              userunit  = userunit,
#                              dimension = dimension,
#                              comments  = comments),
#          envir = .GlobalEnv)
#   
#   # define CaseTStartValue as a 'scalar' variable
#   assign("Test.TStart.Value", Test.TStart$value, envir = .GlobalEnv)
#   
#   # if user, or GUI, changed the dimension, repair and balk
#   if (!Test.TStart$dimension == "[time(1)]") {
#     setTestTStart(dimension = "[time(1)]")
#     print("setTestTStart: dimension cannot be set.")
#   }
#   
#   # print Test.TStart
#   getTestTStart()
# 
# }
# # --(setTestTStart)--------------------------------------------------------.


# # initialize with missing value
# setTestTStart()



# ==[getTestTDepur]========================================================
# to get and set Test.TDepur, onset of depuration phase
# this is usually taken as the end of the uptake phase

# getTestTDepur <- function() {
#   
#   # this is a primitive print method, not yet S3
#   as.data.frame(get("Test.TDepur", envir = .GlobalEnv))
# }
# # --(getTestTDepur)--------------------------------------------------------.
# 
# 
# # ==[setTestTDepur]========================================================
# # function to set Test.TDepur and Test.TDepur.Value
# # todo: annotation for roxygen
# setTestTDepur <- function(value     = NA,                           
#                             userunit  = "[d]",
#                             dimension = "[time(1)]",
#                             comments  = "") {
#   
#   assign("Test.TDepur", list(value     = value,
#                              userunit  = userunit,
#                              dimension = dimension,
#                              comments  = comments),
#          envir = .GlobalEnv)
#   
#   assign("Test.TDepur.Value", Test.TDepur$value, envir = .GlobalEnv)
#   
#   if (!Test.TDepur$dimension == "[time(1)]") {
#     setTestTDepur(dimension = "[time(1)]")
#     print("setTestTDepur: dimension cannot be set.")
#   }
#   
#   # print Test.TDepur
#   getTestTDepur()
# }
# # --(setTestTDepur)--------------------------------------------------------.


# #!!!!!!!!!!
# # initialize with missing value
# # ?? move to initmain
# setTestTDepur()


# ==[getTestTEnd]==========================================================
# to get and set Test.TEnd, end of the depuration phase

# getTestTEnd <- function() {
#   
#   # this is a primitive print method, not yet S3
#   as.data.frame(get("Test.TEnd", envir = .GlobalEnv))
# }
# # --(getTestTDepur)--------------------------------------------------------.
# 
# 
# # ==[setTestTEnd]==========================================================
# # function to set Test.TEnd and Test.TEnd.Value
# # todo: annotation for roxygen
# setTestTEnd <- function(value     = NA,                           
#                           userunit  = "[d]",
#                           dimension = "[time(1)]",
#                           comments  = "") {
#   
#   assign("Test.TEnd", list(value     = value,
#                            userunit  = userunit,
#                            dimension = dimension,
#                            comments  = comments), envir = .GlobalEnv)
#   
#   assign("Test.TEnd.Value", Test.TEnd$value, envir = .GlobalEnv)
#   
#   if (!Test.TEnd$dimension == "[time(1)]") {
#     setTestTEnd(dimension = "[time(1)]")
#     print("setTestTEnd: dimension cannot be set.")
#   }
#   
#   # print Test.TEnd
#   getTestTEnd()
# }
# # --(setTestTEnd)----------------------------------------------------------.
# 
# 
# # !!!!!!!!!!!!!!!!!!!
# # initialize with missing value
# # ?? move to initmain
# setTestTEnd()
# 

# ---INI Test END------------------------------------------.



# ===INIT DATA BEGIN=======================================================




# getInfoWFish <- function() {
#   
#   # this is a primitive print method, not yet S3
#   as.data.frame(get("INFO.FILE.WFISH", envir = .GlobalEnv))
# }
# 
# 
# getInfoCWater <- function() {
#   
#   # this is a primitive print method, not yet S3
#   as.data.frame(get("INFO.FILE.CWATER", envir = .GlobalEnv))
# }

# will be run by enterDataCFish
# setInfoCFish <- function(filename   = "",
#                          datasource = "",
#                          infotime   = varInfo(),
#                          infocfish  = varInfo(),
#                          comments   = "") {
#   assign("INFO.FILE.CFISH",
#          list(filename   = filename,
#               datasource = datasource,
#               infotime   = infotime,
#               infocfish  = infocfish,
#               comments   = comments),
#          envir = .GlobalEnv)
# }


# # will be run by enterDataWFish
# setInfoWFish <- function(filename   = "",
#                          datasource = "",
#                          infotime   = varInfo(),
#                          infowfish  = varInfo(),
#                          comments   = "") {
#   assign("INFO.FILE.WFISH",
#          list(filename   = filename,
#               datasource = datasource,
#               infotime   = infotime,
#               infowfish  = infowfish,
#               comments   = comments),
#          envir = .GlobalEnv)
#   
# } # setInfoWFish.



# # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# # BRING UPTODATE WITH read.Data.WFish, or read.Data.CWFish !!!!!!!!
# # = reads WFish file and builds global DATA.WFISH and DATA.WFISH.TRANS
# #   assumes that INFO.FILE.WFISH has been set in the CASE Module
# # todo: multiple occurrences of a name, case sensitivity (tolower)
# # todo: allow for ;-separated and decimal commas??
# # todo: add other transformations?
# readFileWFish <- function (filewfish = INFO.FILE.WFISH)  {
#   
#   # read data frame from file; may contain unused columns, and userdefined header names
#   TABLE.WFISH <- read.table(filewfish$filename,
#                             comment.char="#",
#                             sep=",",
#                             header=TRUE)
#   
#   columntime  <- which(names(TABLE.WFISH) == filewfish$infotime$header)
#   if(length(columntime)==0)
#     stop("No such header for infotime.")
#   
#   columnwfish <- which(names(TABLE.WFISH) == filewfish$infowfish$header)
#   if(length(columnwfish)==0)
#     stop("No such header for infowfish.")
#   
#   # build fresh WFISH data frame with standard headers and only relevant variables
#   assign("DATA.WFISH", data.frame(.TIME  = TABLE.WFISH[[columntime]],
#                                   .WFISH = TABLE.WFISH[[columnwfish]]),
#          envir = .GlobalEnv)
#   
#   # todo: other transformations?, e.g. log10; Note: log = ln.
#   assign("DATA.WFISH.TRANS", transform(DATA.WFISH, dat.LNWFISH = log(.WFISH)),
#          envir = .GlobalEnv)
#   
# } # readFileWFish.


# does setInfoWFish and readFileWFish in one sweep
# todo: check if better to default with empty info, or don't set defaults at all
# enterDataWFish <- function(filename   = "",
#                            datasource = "",
#                            infotime   = var.Info(),
#                            infowfish  = var.Info(),
#                            comments   = "") {
#   
#   # sets the file info, column info, user units
#   setInfoWFish(filename   = filename,
#                datasource = datasource,
#                infotime   = infotime,
#                infowfish  = infowfish,
#                comments   = comments)
#   
#   # actually does the read.table, on default 
#   readFileWFish()
#   
# } # enterDataWFish.



# ==[stdErrBCFSimul]=======================================================

# Mood,Graybill,Boes (1974), p.181

stdErrBCFSimul <- function(coefvec,
                           varcovmat,
                           parkg = 0.) {
  
  #--get k1, k2 point estimates
  k1hat <- coefvec[1]
  k2hat <- coefvec[2]
  
  #--get k1 and k2 variances from var-covar matrix
  k1var <- varcovmat[1,1]
  k2var <- varcovmat[2,2]
  
  #--get k1 and k2 covariance
  k1k2cov <- varcovmat[1,2]
  
  #--growth-corrected k2
  k2g <- k2hat - parkg
  
  #--standard error of BCF
  stderrbcf <- k1hat/k2g*sqrt(k1var/k1hat^2 + k2var/k2g^2 - 2*k1k2cov/k1hat/k2g)
  
  return(stderrbcf)
}

# --(stdErrBCFSimul)-------------------------------------------------------.



"boxcox2.nls" <- function(object, lambda = seq(-2, 2, 1/100), plotit = TRUE, start,
                          eps = 1/50, bcAdd = 0, level = 0.95, xlab = expression(lambda), ylab = "log-likelihood", ...)
{
  ## Defining the Box-Cox modified power transformations
  bfFct <- function(lv)
  {
    function(x) {if (abs(lv) < eps) {return(log(x+bcAdd))} else {return(((x+bcAdd)^lv-1)/lv)}}    
  }
  
  evalForm <- eval(formula(object)[[3]][[1]])
  bfFct2 <- function(lv)
  {
    bcFct2 <- function(x)
    {
      ## Transforming the mean
      bcFct <- bfFct(lv)
      bcFctVal <- bcFct(x)
      
      #            ## Assigning sttributes
      #            attrList <- attributes(evalForm)
      #            lenAL <- length(attrList)
      #            namAL <- names(attrList)
      #     
      #            for (i in 1:lenAL)
      #            {
      ##                attr(bcFctVal, namAL[i]) <- attrList[[i]]
      #            }
      #            
      ## Adjusting gradient
      grad1 <- attr(bcFctVal, "gradient")
      grad2 <- grad1*(x^(lv-1))
      attr(bcFctVal, "gradient") <- grad2 
      
      bcFctVal
    }
    bcFct2
  }
  
  if (!inherits(evalForm , "selfStart"))
  {
    bfFct2 <- bfFct
  }    
  
  #    bcFct <- function(x) {if (abs(lv) < eps) {return(log(x+bcAdd))} else {return(((x+bcAdd)^lv-1)/lv)}}
  #    assign("bcFct", bcFct, envir = .GlobalEnv)
  #    newFormula <- bcFct(.) ~ bcFct(.)
  if (missing(start)) 
  {
    startVec <- coef(object)
  } else {
    startVec <- start
  }
  names(startVec) <- names(coef(object))
  
  ## Retrieving the dataset
  origData <- eval(object[["call"]][["data"]], envir = object[["m"]]$getEnv())
  
  ## Defining the log-likelihood function
  llFct <- function(object, lv)
  {
    sumObj <- summary(object)
    N <- sum(sumObj$df)
    Ji <- (eval(object$data)[, as.character(formula(object)[[2]])[2]])^(lv-1)
    #        Ji <- (origData[, as.character(formula(object)[[2]])[2]])^(lv-1)
    
    return(-N*log(sqrt(sum(residuals(object)^2)/N))-N/2+sum(log(Ji)))
  }
  
  lenlam <- length(lambda)
  llVec <- rep(NA, lenlam)
  for (i in 1:lenlam)
  {
    lv <- lambda[i]
    assign("bcFct", bfFct(lambda[i]), envir = .GlobalEnv)     
    newFormula <- bcFct1(.) ~ bcFct2(.)          
    assign("bcFct1", bfFct(lambda[i]), envir = .GlobalEnv)     
    assign("bcFct2", bfFct2(lambda[i]), envir = .GlobalEnv)     
    nlsTemp <- try(update(object, formula. = newFormula, data = origData, start = startVec, trace = FALSE), silent = TRUE)
    
    if (FALSE)
    {
      bcFct1 <- bfFct(lambda[i])
      bcFct2 <- bfFct2(lambda[i])
      
      environment(bcFct1) <- object[["m"]]$getEnv()
      environment(bcFct2) <- object[["m"]]$getEnv()
      
      
      oldFormula <- as.formula(deparse(formula(object)), env = object[["m"]]$getEnv())
      newFormula0 <- bcFct1(.) ~ bcFct2(.)
      newFormula <- update(oldFormula, newFormula0)
      #        print("hej")
      print(newFormula)
      nlsTemp <- try(update(object, formula. = newFormula, 
                            start = startVec, trace = TRUE), silent = FALSE)
    }
    #        print(nlsTemp)
    #        if (!inherits(nlsTemp, "try-error")) {llVec[i] <- logLik(nlsTemp)}
    if (!inherits(nlsTemp, "try-error")) {llVec[i] <- llFct(nlsTemp, lambda[i])}
  }
  
  lv <- lambda[which.max(llVec)]
  llv <- max(llVec, na.rm = TRUE)
  ci <- boxcoxCI(lambda, llVec, level)
  
  if (plotit)  # based on boxcox.default
  {
    plot(lambda, llVec, type ="l", xlab = xlab, ylab = ylab, ...)
    
    plims <- par("usr")
    y0 <- plims[3]
    lim <- llv-qchisq(level, 1)/2
    
    segments(lv, llv, lv, y0, lty=3)
    segments(ci[1], lim, ci[1], y0, lty = 3)  # lower limit
    segments(ci[2], lim, ci[2], y0, lty = 3)  # upper limit
    
    scal <- (1/10 * (plims[4] - y0))/par("pin")[2] 
    scx <- (1/10 * (plims[2] - plims[1]))/par("pin")[1] 
    text(lambda[1] + scx, lim + scal, " 95%") 
    abline(h = lim, lty = 3)
    
  }
  assign("bcFct", bfFct(lv), envir = .GlobalEnv) 
  assign("bcFct1", bfFct(lv), envir = .GlobalEnv) 
  assign("bcFct2", bfFct2(lv), envir = .GlobalEnv) 
  retFit <- update(object, formula. = newFormula, data = origData, start = startVec, trace = FALSE)  
  
  if (FALSE)
  {
    retFit <- nls(newFormula, 
                  data = origData,
                  start = startVec, trace = FALSE)
    # last time 'bcFct1' and 'bcFct2' are used
    #    rm(bcFct1, bcFct2, envir = .GlobalEnv)  # to ensure that the predict method can find bcFct2()
  }
  retFit$lambda <- list(lambda = lv, ci = ci)
  invisible(retFit)
}


"boxcoxCI" <- 
  function(x, y, level = 0.95)
  {
    ## R lines taken from boxcox.default in the package MASS and then slightly modified
    xl <- x
    loglik <- y
    
    llnotna <- !is.na(loglik)
    xl <- xl[llnotna]
    loglik <- loglik[llnotna]
    
    m <- length(loglik)
    
    mx <- (1:m)[loglik == max(loglik)][1]
    Lmax <- loglik[mx]
    lim <- Lmax - qchisq(level, 1)/2
    
    ind <- range((1:m)[loglik > lim])
    
    xx <- rep(NA, 2)
    if(loglik[1] < lim) 
    {
      i <- ind[1]
      xx[1] <- xl[i - 1] + ((lim - loglik[i - 1]) *
                              (xl[i] - xl[i - 1]))/(loglik[i] - loglik[i - 1])
      
    }
    if(loglik[m] < lim) 
    {
      i <- ind[2] + 1
      xx[2] <- xl[i - 1] + ((lim - loglik[i - 1]) *
                              (xl[i] - xl[i - 1]))/(loglik[i] - loglik[i - 1])
    }
    return(xx)
  }

"bcSummary" <- function(object)
{
  cat("\n")
  cat("Estimated lambda:", object$lambda$lambda, "\n")
  
  bcci <- format(object$lambda$ci, digits = 2)
  ciStr <- paste("[", bcci[1], ",", bcci[2], "]", sep="")
  cat("Confidence interval for lambda:", ciStr, "\n\n")    
}


# modelFit_BoxCoxLambda <- function(modelfit) {
#   bcmf <- boxcox2.nls(modelfit)
#   bcSummary(bcmf)
# }

# ~~~ add profile.plot = FALSE??
ModelTrans_BoxCox <- function(modelfit) {
 
  bcmf <- boxcox2.nls(modelfit)
  
  lambdafit <- bcmf$lambda$lambda
  
  lambdaconf <- bcmf$lambda$ci
  
  lambdaest <- c(lambdafit, lambdaconf)
  names(lambdaest) <- c("fit","conflo", "confup")
  
  return(lambdaest)
}


# nlstools:
modelDiag_Generic <- function(modelfit) {
  nlsresun <- nlsResiduals(modelfit)
  plot(nlsresun)
  test.nlsResiduals(nlsresun)  
}



# ---INIT DATA END------------------------------------------.


# == ADDITIONAL FUNCTIONS ================================================= 
# todo: add kurtosis, test significance if Normal is expected?
skew <- function(x) {
  # Crawley (2007), p.285
  m3 <- sum((x-mean(x))^3)/length(x)
  s3 <- sqrt(var(x))^3
  m3/s3
} # skew.


# Mark van der Loo (2014-08) in R-bloggers.com
sort.data.frame <- function(x, decreasing=FALSE, by=1, ... ){
  f <- function(...) order(..., decreasing=decreasing)
  i <- do.call(f,x[by])
  x[i,,drop=FALSE]
} # sort.data.frame
# == ADDITIONAL FUNCTIONS =====.


# _________________________________________________________________________
# %% END OF R-SOURCE %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%