# bcmf_runaqua_1.R


RUN_Aqueous <- function(testfile.csvy) {
  
  # title and program version
  cat("\nRUN AQUEOUS (Untransformed). Version:", PROG.Version, "\n")

  
  # --- READ AQUEOUS TEST DATA

  # read aqueous test data from a .csvy file
  cat("\nAQUEOUS TEST READ: ", testfile.csvy, "\n\n")
  print(readTest_Aqueous(testfile.csvy))

  # show the test conditions
  cat("\nTEST.Aqueous.Param: \n\n")
  print(TEST.Aqueous.Param)


  # --- FIT BCF MODEL UNTRANSFORMED & DIAGNOSTICS

  # fit untransformed
  cat("\nMODEL FIT (Untransformed):\n\n")
  print(fitModel_Aqueous())

  # check model diagnostics
  cat("\nMODEL DIAGNOSTICS (Untransformed):\n")
  print(modelDiag_Aqueous())
  
  
  # --- PLOT BEST FIT UNTRANSFORMED

  # calculate best fit on untransformed scale
  runBestFit_Aqueous()

  # plot best fit on untransformed scale
  plotBestFit_Aqueous()
  
  
  # --- UNTRANSFORMED CONFIDENCE LIMITS ----------

  # Bayesian bootstrap for untransformed fit
  bootModel_Aqueous()

  # scatter plot bootstrap param
  # print(qplot(BCF.ParamBoot$k2.boot, BCF.ParamBoot$k1.boot))
  
  # print(summary(BCF.ParamBoot$k1.boot))
  # print(summary(BCF.ParamBoot$k2.boot))
  
  # prep lower and upper confidence limits of fit
  runConfFit_Aqueous()

  # plot them untransformed
  plotConfFit_Aqueous()
  
  
  # --- SHOW BCF SUMMARY TABLE (UNTRANSFORMED)

  # Test Parameters
  cat("\nAQUEOUS TEST PARAMETERS:\n\n")
  print(TEST.Aqueous.Param)

  # BCF summary Table for untransformed fit
  cat("\nUNTRANSFORMED SUMMARY TABLE:\n\n")
  print(summaryTable_Aqueous(digits = 5))

  cat("\n(End of RUN_Aqueous)\n\n")

}

##############################
